program Himage

  use sep

  implicit none

  integer                              :: n1, n2, n3, n3s, k
  real                                 :: o1, d1, o2, d2, o3, d3, e0, e1
  real, dimension(:,:,:), allocatable  :: data, data2

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)

  if(o3 .ne. -(n3-1.)/2) call erexit("needs symmetric h-axis")

  allocate(data(n1,n2,n3))
  call sep_read(data)
  e0 = sqrt(sum(data*data)-sum(data(:,:,1-o3)*data(:,:,1-o3)))

  do k=1,n3/2
    e1 = sqrt(sum(data(:,:,1:k)*data(:,:,1:k))+sum(data(:,:,n3-k+1:n3)*data(:,:,n3-k+1:n3)))
    if(e1>e0/50.) exit
  end do

  n3s = n3-2*(k-1)
  allocate(data2(n1,n2,n3s))
  data2 = data(:,:,k:n3-k+1)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)
  call to_history("n3", n3s)
  call to_history("o3", -(n3s-1.)/2)
  call to_history("d3", d3)

  call sep_write(data2)

  call sep_close()
end program
