program Himage

  use sep

  implicit none

  integer                              :: n1, n2, i, j
  real                                 :: o1, d1, o2, d2
  real, dimension(:,:), allocatable    :: model, data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

  allocate(model(n1,n2), data(n1,n2))

  model = 0.
  data = 0.

  call sep_read(model)

  do j=2,n2-1
    do i=2,n1-1
      data(i,j) = -4.*model(i,j) + model(i-1,j) + model(i+1,j) + model(i,j-1) + model(i,j+1)
    enddo
  enddo

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  call sep_write(data)

  call sep_close()
end program
